/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.tables.records.TCoreCloneRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreClone extends TableImpl<TCoreCloneRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_clone</code>
     */
    public static final TCoreClone T_CORE_CLONE = new TCoreClone();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreCloneRecord> getRecordType() {
        return TCoreCloneRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_clone.lastchange</code>.
     */
    public final TableField<TCoreCloneRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_clone.pk</code>. unique id
     */
    public final TableField<TCoreCloneRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "unique id");

    /**
     * The column <code>common_dd.t_core_clone.original</code>. reference to
     * original element
     */
    public final TableField<TCoreCloneRecord, Integer> ORIGINAL = createField(DSL.name("original"), SQLDataType.INTEGER.nullable(false), this, "reference to original element");

    /**
     * The column <code>common_dd.t_core_clone.cloned</code>. reference to
     * cloned element
     */
    public final TableField<TCoreCloneRecord, Integer> CLONED = createField(DSL.name("cloned"), SQLDataType.INTEGER.nullable(false), this, "reference to cloned element");

    /**
     * The column <code>common_dd.t_core_clone.finished</code>. timestamp of
     * finished clone
     */
    public final TableField<TCoreCloneRecord, LocalDateTime> FINISHED = createField(DSL.name("finished"), SQLDataType.LOCALDATETIME(6), this, "timestamp of finished clone");

    /**
     * The column <code>common_dd.t_core_clone.uuid</code>. unique id of clone
     * operation
     */
    public final TableField<TCoreCloneRecord, LocalDateTime> UUID = createField(DSL.name("uuid"), SQLDataType.LOCALDATETIME(6).nullable(false), this, "unique id of clone operation");

    private TCoreClone(Name alias, Table<TCoreCloneRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreClone(Name alias, Table<TCoreCloneRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_clone</code> table reference
     */
    public TCoreClone(String alias) {
        this(DSL.name(alias), T_CORE_CLONE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_clone</code> table reference
     */
    public TCoreClone(Name alias) {
        this(alias, T_CORE_CLONE);
    }

    /**
     * Create a <code>common_dd.t_core_clone</code> table reference
     */
    public TCoreClone() {
        this(DSL.name("t_core_clone"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_CLONE, Indexes.IDX_CLONE_CLONED, Indexes.IDX_CLONE_ORIGINAL);
    }

    @Override
    public Identity<TCoreCloneRecord, Integer> getIdentity() {
        return (Identity<TCoreCloneRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreCloneRecord> getPrimaryKey() {
        return Keys.PK_CORE_CLONE;
    }

    @Override
    public List<UniqueKey<TCoreCloneRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_CLONE);
    }

    @Override
    public TCoreClone as(String alias) {
        return new TCoreClone(DSL.name(alias), this);
    }

    @Override
    public TCoreClone as(Name alias) {
        return new TCoreClone(alias, this);
    }

    @Override
    public TCoreClone as(Table<?> alias) {
        return new TCoreClone(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreClone rename(String name) {
        return new TCoreClone(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreClone rename(Name name) {
        return new TCoreClone(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreClone rename(Table<?> name) {
        return new TCoreClone(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreClone where(Condition condition) {
        return new TCoreClone(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreClone where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreClone where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreClone where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreClone where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreClone where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreClone where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreClone where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreClone whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreClone whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
